using System; 
using System.Runtime.InteropServices; 
using System.ComponentModel;

class SomeObject
{
	public void Test()
	{
        Console.WriteLine("Test");
	}
}


class MainClass
{
    [DllImport("40.dll"/*, CharSet = CharSet.Unicode, EntryPoint = "MyFunc"*/)]
    public static extern void MyFunc([In, MarshalAs(UnmanagedType.IUnknown)] Object o);

    static void Main(string[] args)
    {
        Object o;

        if (args.Length > 0 && args[0].ToLower().Equals(@"demo"))
        {
            o = Activator.CreateInstance(Type.GetTypeFromProgID("Demo.Scriptlet"));

            // drive IDispatch, just to test the object
            
            String line = (String) o.GetType().InvokeMember("Method1", System.Reflection.BindingFlags.InvokeMethod, null, o, new object[] { @"C# Test" } );
            Console.WriteLine(line);

            line = (String) o.GetType().InvokeMember("Property1", System.Reflection.BindingFlags.GetProperty, null, o, new object[] { } );
            Console.WriteLine(line);
        }
        else if (args.Length > 0 && args[0].ToLower().Equals(@"xl"))
        {
            o = Activator.CreateInstance(Type.GetTypeFromProgID("Excel.Application"));
        }
        else
            o = new SomeObject();

        MyFunc(o);
    }
}
